

#include "mydatad.h"
#include "usart.h"
#include "stack.h"
#include <stdio.h>

char * mydata_retransmission_pointer ;

//----------------------------------------------------------------------------
//Initialisierung des mydata Servers
void mydata_init (void)
{
  //Serverport und Anwendung eintragen
  add_tcp_app (mydataD_PORT, (void(*)(unsigned char))mydatad);
  usart_write("myDataD aktiv\r\n");

}


//----------------------------------------------------------------------------
//mydata Server
void mydatad (U8 index){
  U16 a = 0;
  char c;


  if (tcp_entry[index].status & FIN_FLAG)
  {
    mydatad_status.connected = 0;
    return;
  }

  //Verbindungsaufbau (erstes Paket)  
  if (tcp_entry[index].app_status == 0 || tcp_entry[index].app_status == 1)
  {
    tcp_entry[index].app_status = 1;
    tcp_entry[index].status =  ACK_FLAG;
    create_new_tcp_packet(0,index);
    tcp_entry[index].time = TCP_TIME_OFF;
    mydatad_status.ack_wait = 0;
    mydatad_status.connected = 1;
    return;
  }

  //Daten mit gesetztem PUSH-Flag auf offenem Kanal
  if ((tcp_entry[index].app_status > 1) 
   && (tcp_entry[index].status & PSH_FLAG))
  {
    tcp_entry[index].app_status = 2;
    for(a=TCP_DATA_START_VAR; a<(TCP_DATA_END_VAR); a++){
      c = eth_buffer[a];
      usart_write_char(c);
    }


#if 0 //Senden geht nur ca. 10 Mal. Da stimmt was  nicht
    U16 hex;
    U8 i;
    for (i=0; i<10; i++){
      eth_buffer[TCP_DATA_START_VAR + i] = 65+i;
    }
    hex = tcp_entry[index].app_status;
    eth_buffer[TCP_DATA_START_VAR + 0] = 48+hex / 4096; hex %=4096;
    eth_buffer[TCP_DATA_START_VAR + 1] = 48+hex / 256; hex %=256;
    eth_buffer[TCP_DATA_START_VAR + 2] = 48+hex / 16; hex %=16;
    eth_buffer[TCP_DATA_START_VAR + 3] = 48+hex ;
    eth_buffer[TCP_DATA_START_VAR + 4] = 32 ;

    for (i=0; i<4; i++){
      if (eth_buffer[TCP_DATA_START_VAR + i] > 57)  eth_buffer[TCP_DATA_START_VAR + i]+=7;
    }
    eth_buffer[TCP_DATA_START_VAR + 10] = 13;

    tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
    create_new_tcp_packet(11, index);

#else //Nur ACK senden
    tcp_entry[index].status =  ACK_FLAG;
    create_new_tcp_packet(0, index);
#endif    
    return;
  }
  
    
  //Ack erhalten (vom gesendeten Packet)
  if (    (tcp_entry[index].app_status > 1)
        &&(tcp_entry[index].status & ACK_FLAG)
        &&(mydatad_status.ack_wait))
  {
    tcp_entry[index].time = TCP_TIME_OFF;
    tx_buffer_pointer_out =  mydata_retransmission_pointer ;
    mydatad_status.ack_wait = 0;
    return;
  }

  //Time out - kein ACK angekommen
  if (tcp_entry[index].status == 0) 
  {
    //Daten nochmal senden
    mydatad_status.ack_wait = 0;
    mydatad_send_data ();
    return;
  }
   
    
  return;
}




//----------------------------------------------------------------------------
void mydatad_send_data (void)
{
  U8 index;
  if (tx_buffer_pointer_in !=  mydata_retransmission_pointer )
  {
    for (index = 0;index<MAX_TCP_ENTRY;index++)
    {
      if(tcp_entry[index].dest_port == LBBL_ENDIAN_INT(mydataD_PORT))
      {
        if(!mydatad_status.ack_wait)
        {
          mydatad_status.ack_wait = 1;
          unsigned int count = 0;
           mydata_retransmission_pointer  = tx_buffer_pointer_out; 
          
          while(tx_buffer_pointer_in !=  mydata_retransmission_pointer )
          {
            eth_buffer[TCP_DATA_START+count] = * mydata_retransmission_pointer ++;
            count++;
            if ( mydata_retransmission_pointer  == &mydata_tx_buffer[mydata_BUFFER_SIZE-1])
            {
               mydata_retransmission_pointer  = &mydata_tx_buffer[0];
            }
          }
          tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
          create_new_tcp_packet(count,index);
          tcp_entry[index].time = TCP_MAX_ENTRY_TIME;
          return;
        }
        else
        {
          return;
        }
      }
    }
  }
}


//----------------------------------------------------------------------------
//Ausgabe eines Zeichens ber den Socket
//----------------------------------------------------------------------------
void mydata_write_char(char c){
#if 1
    if((tx_buffer_pointer_out - 1) == tx_buffer_pointer_in ) //Warnung: Klappt nicht, wenn pointer In am Pufferende steht
    {
        //Datenverlust
        mydatad_send_data ();
        while(mydatad_status.ack_wait)
        {
            eth_get_data();
        }
    }
#endif
    *tx_buffer_pointer_in++ = c;

    if (&mydata_tx_buffer[mydata_BUFFER_SIZE-1] == tx_buffer_pointer_in)
    {
        tx_buffer_pointer_in = &mydata_tx_buffer[0];
    }
#if 0
    if (13 == c){ //Telegrammende (Zeilenende)
       mydatad_send_data ();
    }
#endif    
    return;
}
